  

        // LOCUS * * * * * * /
  
  function jspLocus(e, elid, obj_c, calc, use_hide_el, evaluated_el) {
        
          // First let's check if Locus is replaced
          // el.locusToReplace = row of the locus
          // el.replaceLocus = replace function as string "function(x){something...}"
          
          if(e.JSPComment.indexOf('locus')>=0) {
            try {
              var lrtmp1 = lrtmp2 = ''; 
              while (e.replaceLocus.indexOf('@')>0) {
                lrtmp1 = e.replaceLocus.slice(e.replaceLocus.indexOf('@'), e.replaceLocus.indexOf('@', e.replaceLocus.indexOf('@')+1)+1);
                if (calc[eval(lrtmp1.slice(1,lrtmp1.length-1))])
                  lrtmp2 = calc[eval(lrtmp1.slice(1,lrtmp1.length-1))];
                else lrtmp2 = elid + "_el[" + lrtmp1.slice(1,lrtmp1.length-1) +"]";
                e.replaceLocus = e.replaceLocus.replace(lrtmp1, lrtmp2);
                e.replaceLocus += ', ' + setAttributes(e,"",use_hide_el,elid);
              } 

              output = obj_c+"( "+e.replaceLocus+ ");"
            } catch(err) {alert(err.message + err);}
          } else {
            // JSP description: Locus(obj1, obj2, obj3, num);
              //Constructs the locus of obj1 as point obj2 moves along the path determined by obj3. 
              //JavaSketchpad devotes num samples to the representation of the locus--higher values of 
              //num correspond to more accurate approximations of the locus, but take more time and computer memory to process.
            var usertick = 1/30; //set user ticks here
            //if (e.Opts.indexOf('ticks(')> 0) usertick = eval(e.Opts.slice(e.Opts.indexOf('ticks(')+6, e.Opts.indexOf(')',e.Opts.indexOf('ticks(')+6)));
            //usertick = 1/usertick;
            if (e.Pos[3] <= 20) usertick = 1/eval(e.Pos[3]);
            else usertick = 1/((eval(e.Pos[3]) / 21) + 20); 

            // If locus is created by path of a glider, locus will be created as a tracecurve construction in JSXGraph
            if (eval(elid+"_el["+e.Pos[1]+"]").getType() == 'glider')
              output = obj_c+"('tracecurve', ["+elid+"_el["+e.Pos[1]+"],"+elid+"_el["+e.Pos[0]+"]], {name:'"+e.Att.Name+"', strokeColor:'"+e.Att.Color+"', visible:"+e.Att.Visible+", numberPoints:"+e.Pos[3]+", highlight:false} );";
            
            
            else if (eval(elid+"_el["+e.Pos[1]+"]").getType() == 'point') {
                
                locus_counter = locus_counter +1;
                var lrobj = [];
                var end_gh_r = eval(e.Pos[0]);
                var k = eval(e.Pos[1]);
                var need_to_duplicate = [];
                var tmp_listnr = 0;
                var tmp_duplicate = "";
                var tmp_duplicates = [];
                var tmp_tmp = "";
                var numPoints = eval(e.Pos[3]);
                    if (numPoints<50) numPoints = 50;
                    else if (numPoints>100) numPoints = 100;

              if (el[e.Pos[2]].JsxType == 'circle') {
                
                if (!curvelocus) {

                  lrobj.push(eval(e.Pos[1])); //starting row to check + duplicate

                  need_to_duplicate.push(eval(e.Pos[1]));
                  
                  while(k < end_gh_r) {
                    k = k+1;
                    for (var j=0; j<need_to_duplicate.length; j++) {
                      if (evas[el[k].Row].indexOf(elid+"_el["+need_to_duplicate[j]+"]")>=0 && need_to_duplicate.indexOf(k)<0) {
                        need_to_duplicate.push(k);
                      }
                    }
                  } // here is the list for lines needed to duplicate : alert(need_to_duplicate);

                  if (el[need_to_duplicate[0]].JsxType == 'point')
                    tmp_duplicates.push( "var " + elid + "_dup"+locus_counter+" = [];\n"+ 
                                      elid + "_dup"+locus_counter+"["+need_to_duplicate[0]+"] = " + boardname + "_b.create('glider', ["+elid+"_el["+e.Pos[2]+"]], );\n"+ elid + "_dup"+locus_counter+"["+need_to_duplicate[0]+"].hideElement();");
                  else {alert("Something went wrong in Locus operation!"); return null;}

                  for (var j = 1; j<need_to_duplicate.length; j++) {
                    tmp_duplicate = evas[need_to_duplicate[j]];
                    for (var m=0; m<need_to_duplicate.length; m++) {
                      while(tmp_duplicate.indexOf(elid+"_el["+need_to_duplicate[m]+"]")>=0)
                        tmp_duplicate = tmp_duplicate.replace(elid+"_el["+need_to_duplicate[m]+"]", elid + "_dup"+locus_counter+"["+need_to_duplicate[m]+"]");
                      while(tmp_duplicate.indexOf(elid + "_dup"+locus_counter+"["+need_to_duplicate[m]+"].hideElement();")>=0)
                        tmp_duplicate = tmp_duplicate.replace(elid + "_dup"+locus_counter+"["+need_to_duplicate[m]+"].hideElement();", "\n");
                      
                      if (tmp_duplicate.indexOf('],{')>0) {
                        tmp_tmp = tmp_duplicate.slice(tmp_duplicate.indexOf('],{')+2, tmp_duplicate.lastIndexOf('}')+1);
                        tmp_duplicate = tmp_duplicate.replace(tmp_tmp, " {} ");
                      }                   
                    }
                    tmp_duplicates.push(tmp_duplicate + elid + "_dup"+locus_counter+"["+need_to_duplicate[j]+"].hideElement()");
                  }    
                  output = "";
                  for (var j=0; j<tmp_duplicates.length; j++) {
                    output += tmp_duplicates[j] + "\n";
                  } 
                  output += obj_c + "('tracecurve', ["+elid+"_dup"+locus_counter+"["+e.Pos[1]+"],"+elid+"_dup"+locus_counter+"["+e.Pos[0]+"]], {name:'"+e.Att.Name+"', strokeColor:'"+e.Att.Color+"', visible:"+e.Att.Visible+", numberPoints:"+numPoints+", highlight:false} );";
                }


                // If locus is created by path that is circle or segment, and a point other than glider mover along that path, locus will be created by this algorithm
                // Algorithm creates locus like explained next:
                // - make the point to be a gliderpoint on wanted path
                // - move point along that path distance of a tick (user can define, default is 30 ticks)
                // - while point is moving along path, collect the coordinatedata of the point we want to draw the locus
                // - clear all old segments if there are any, and create segments between all the coordinatepoint from the data
                // - make point not to be gliderpoint anymore, and return it to its startingpoint
                // - make events for the nessessary objects to launch this function
                else {                       
                  // vanhja "toimiva"
                  //output = "var "+elid+e.Row+"visible="+e.Att.Visible+";"+ elid+"_el["+e.Row+"]=[]; function "+elid+"Locus"+e.Row+"(obj1,obj2,obj3){var objstart=[obj3.X(),obj3.Y()];var locuspath=[];var tick=0;obj3.makeGlider(obj1);while(tick<=1.02){obj3.setGliderPosition(tick); locuspath.push([obj2.X(),obj2.Y()]); tick=tick+"+usertick+";} for(var i=0; i<locuspath.length; i++){"+boardname+"_b.removeObject("+elid+"_el["+e.Row+"][i]); if(i==0)"+elid+"_el["+e.Row+"][i]="+boardname+"_b.create('segment',[locuspath[i],locuspath[locuspath.length-1]],{strokeWidth:1,fixed:true,visible:"+elid+e.Row+"visible}); else "+elid+"_el["+e.Row+"][i]="+boardname+"_b.create('segment',[locuspath[i-1],locuspath[i]],{strokeWidth:1,fixed:true, visible:"+elid+e.Row+"visible}); } if(!"+elid+"_animOn){obj3.free(); obj3.setPosition(JXG.COORDS_BY_USER, objstart); "+boardname+"_b.update();} return locuspath; }"; 
                  output = "var "+elid+e.Row+"visible="+e.Att.Visible+";"+ elid+"_el["+e.Row+"]=[]; \n"+
                                    "function "+elid+"Locus"+e.Row+"(obj1,obj2,obj3){\n\t"+
                                      "var objstart=[obj3.X(),obj3.Y()],\n\t"+
                                      "\tlocuspathx=[], locuspathy=[],\n\t"+
                                      "\ttick=0;\n\t"+
                                      "obj3.makeGlider(obj1);\n\t"+
                                      "while(tick<=1.00){\n\t\t"+
                                        "obj3.setGliderPosition(tick); \n\t\t"+
                                        "locuspathx.push(obj2.X()); \n\t\t"+
                                        "locuspathy.push(obj2.Y()); \n\t\t"+
                                        "tick=tick+"+usertick+";} \n\t"+
                                      boardname+"_b.removeObject("+elid+"_el["+e.Row+"][0]); \n\t"+
                                      elid+"_el["+e.Row+"][0]="+boardname+"_b.create('curve',[locuspathx, locuspathy],{doAdvancedPlot:false,numberPointsLow:10,numberPointsHigh:10, strokeWidth:1,fixed:true,visible:"+elid+e.Row+"visible});  \n\t"+
                                      "if(!"+elid+"_animOn){\n\t\t"+
                                        "obj3.free(); \n\t\t"+
                                        "obj3.setPosition(JXG.COORDS_BY_USER, objstart); \n\t\t"+
                                        boardname+"_b.update();\n\t} \n"+
                                    "}"; 
                                    //alert(output);
                  output += elid+"Locus"+e.Row+"("+elid+"_el["+e.Pos[2]+"],"+elid+"_el["+e.Pos[0]+"],"+elid+"_el["+e.Pos[1]+"]);\n";
                  output += 
                                    elid+"_el["+e.Pos[2]+"].on('up', function() {\n"+
                                    "\t"+ elid+"Locus"+e.Row+"("+elid+"_el["+e.Pos[2]+"],"+elid+"_el["+e.Pos[0]+"],"+elid+"_el["+e.Pos[1]+"]);\n});\n"+
                                    elid+"_el["+e.Pos[2]+"].center.on('up', function() {\n"+
                                    "\t"+ elid+"Locus"+e.Row+"("+elid+"_el["+e.Pos[2]+"],"+elid+"_el["+e.Pos[0]+"],"+elid+"_el["+e.Pos[1]+"]);\n});";
                  if (el[e.Pos[2]].JsxType == 'circle') {                  
                                    output += 
                                    elid+"_el["+el[el[e.Pos[2]].Pos[1]].Row+"].on('up', function() {\n"+
                                    "\t"+ elid+"Locus"+e.Row+"("+elid+"_el["+e.Pos[2]+"],"+elid+"_el["+e.Pos[0]+"],"+elid+"_el["+e.Pos[1]+"]);\n});";
                  }
                }
              }
              else if (el[e.Pos[2]].JsxType == 'segment') {
                
                if (!curvelocus) {
                  lrobj.push(eval(e.Pos[1])); //starting row to check + duplicate
                  //alert(lrobj[0] +","+  end_gh_r);
                  need_to_duplicate.push(eval(e.Pos[1]));

                  while(k < end_gh_r) {
                    k = k+1;
                    for (var j=0; j<need_to_duplicate.length; j++) {
                      if (evas[el[k].Row].indexOf(elid+"_el["+need_to_duplicate[j]+"]")>=0 && need_to_duplicate.indexOf(k)<0) {
                        need_to_duplicate.push(k);
                      }
                    }
                  } // here is the list for lines needed to duplicate : alert(need_to_duplicate);

                  if (el[need_to_duplicate[0]].JsxType == 'point')
                    tmp_duplicates.push( "var " + elid + "_dup"+locus_counter+" = [];\n"+ 
                                      elid + "_dup"+locus_counter+"["+need_to_duplicate[0]+"] = " + boardname + "_b.create('glider', ["+elid+"_el["+e.Pos[2]+"]], );\n"+ elid + "_dup"+locus_counter+"["+need_to_duplicate[0]+"].hideElement();");
                  else {alert("Something went wrong in Locus operation!"); return null;}

                  for (var j = 1; j<need_to_duplicate.length; j++) {
                    tmp_duplicate = evas[need_to_duplicate[j]];
                    for (var m=0; m<need_to_duplicate.length; m++) {
                      while(tmp_duplicate.indexOf(elid+"_el["+need_to_duplicate[m]+"]")>=0)
                        tmp_duplicate = tmp_duplicate.replace(elid+"_el["+need_to_duplicate[m]+"]", elid + "_dup"+locus_counter+"["+need_to_duplicate[m]+"]");
                      while(tmp_duplicate.indexOf(elid + "_dup"+locus_counter+"["+need_to_duplicate[m]+"].hideElement();")>=0)
                        tmp_duplicate = tmp_duplicate.replace(elid + "_dup"+locus_counter+"["+need_to_duplicate[m]+"].hideElement();", "\n");
                      
                      if (tmp_duplicate.indexOf('],{')>0) {
                        tmp_tmp = tmp_duplicate.slice(tmp_duplicate.indexOf('],{')+2, tmp_duplicate.lastIndexOf('}')+1);
                        tmp_duplicate = tmp_duplicate.replace(tmp_tmp, " {} ");
                      }                   
                    }
                    tmp_duplicates.push(tmp_duplicate + elid + "_dup"+locus_counter+"["+need_to_duplicate[j]+"].hideElement()");
                  }    
                  output = "";
                  for (var j=0; j<tmp_duplicates.length; j++) {
                    output += tmp_duplicates[j] + "\n";
                  } 
                  output += obj_c + "('tracecurve', ["+elid+"_dup"+locus_counter+"["+e.Pos[1]+"],"+elid+"_dup"+locus_counter+"["+e.Pos[0]+"]], {name:'"+e.Att.Name+"', strokeColor:'"+e.Att.Color+"', visible:"+e.Att.Visible+", numberPoints:"+numPoints+", highlight:false} );";
                }

                else {
                  //vanha "toimiva"
                  //output = "var "+elid+e.Row+"visible="+e.Att.Visible+";"+ elid+"_el["+e.Row+"]=[]; function "+elid+"Locus"+e.Row+"(obj1,obj2,obj3){var objstart=[obj3.X(),obj3.Y()];var locuspath=[];var tick=0;obj3.makeGlider(obj1);while(tick<=1.02){obj3.setGliderPosition(tick); locuspath.push([obj2.X(),obj2.Y()]); tick=tick+"+usertick+";} for(var i=0; i<locuspath.length; i++){"+boardname+"_b.removeObject("+elid+"_el["+e.Row+"][i]); if(i==0)"+elid+"_el["+e.Row+"][i]="+boardname+"_b.create('segment',[locuspath[i],locuspath[i]],{strokeWidth:1,fixed:true,visible:"+elid+e.Row+"visible}); else "+elid+"_el["+e.Row+"][i]="+boardname+"_b.create('segment',[locuspath[i-1],locuspath[i]],{strokeWidth:1,fixed:true, visible:"+elid+e.Row+"visible}); } if(!"+elid+"_animOn){obj3.free(); obj3.setPosition(JXG.COORDS_BY_USER, objstart); "+boardname+"_b.update();} return locuspath; }"; 
                  output = "var "+elid+e.Row+"visible="+e.Att.Visible+";"+ elid+"_el["+e.Row+"]=[]; \n"+
                                    "function "+elid+"Locus"+e.Row+"(obj1,obj2,obj3){\n"+
                                      "\tvar objstart=[obj3.X(),obj3.Y()],\n\t"+
                                      "\tlocuspathx=[], locuspathy=[],\n"+
                                      "\ttick=0;\n"+
                                      "\tobj3.makeGlider(obj1);\n"+
                                      "\tobj3.setGliderPosition(0);\n"+
                                      "\tlocuspathx.push(obj2.X());locuspathy.push(obj2.Y());\n"+
                                      "\tobj3.setGliderPosition(1);\n"+
                                      "\tlocuspathx.push(obj2.X());locuspathy.push(obj2.Y());\n"+                                                                       
                                      "\t"+boardname+"_b.removeObject("+elid+"_el["+e.Row+"][0]); \n"+
                                      "\t"+elid+"_el["+e.Row+"][0]="+boardname+"_b.create('curve',[locuspathx,locuspathy],{strokeWidth:1,fixed:true,visible:"+elid+e.Row+"visible}); \n"+
                                      "\tif(!"+elid+"_animOn){\n"+
                                      "\t\tobj3.free(); \n"+
                                      "\t\tobj3.setPosition(JXG.COORDS_BY_USER, objstart); \n"+
                                      "\t\t"+boardname+"_b.update();\n"+
                                      "} \n"+
                                      "}"; 
                  output += elid+"Locus"+e.Row+"("+elid+"_el["+e.Pos[2]+"],"+elid+"_el["+e.Pos[0]+"],"+elid+"_el["+e.Pos[1]+"]);";
                  output += 
                                    elid+"_el["+e.Pos[2]+"].on('up', function() {\n"+ 
                                      "\t"+elid+"Locus"+e.Row+"("+elid+"_el["+e.Pos[2]+"],"+elid+"_el["+e.Pos[0]+"],"+elid+"_el["+e.Pos[1]+"]);\n"+
                                    "});\n"+ 
                                    elid+"_el["+e.Pos[2]+"].point1.on('up', function() {\n"+ 
                                      "\t"+elid+"Locus"+e.Row+"("+elid+"_el["+e.Pos[2]+"],"+elid+"_el["+e.Pos[0]+"],"+elid+"_el["+e.Pos[1]+"]);\n"+
                                    "});\n"+ 
                                    elid+"_el["+e.Pos[2]+"].point2.on('up', function(){\n"+ 
                                      "\t"+elid+"Locus"+e.Row+"("+elid+"_el["+e.Pos[2]+"],"+elid+"_el["+e.Pos[0]+"],"+elid+"_el["+e.Pos[1]+"]);\n"+
                                    "});";
                }
              }

              else errors = errors + "Traced point [line:"+e.Pos[1]+"] is not a type 'Point on object' [type is "+el[e.Pos[1]].Type+"].<br> 'Locus' can be constructed for a 'Point'-element only if path [line:"+e.Pos[2]+"] in 'Circle' or 'Segment'.<br>Locus [line:"+e.Row+"] was not constructed!<br><br>";
            }
            else 
              //output = obj_c+"('locus', ["+elid+"_el["+e.Pos[0]+"]], {name:'"+e.Att.Name+"', strokeColor:'"+e.Att.Color+"', visible:"+e.Att.Visible+"} );";
              errors = errors + "Error on line ["+e.Row+"]: Traced point on line ["+e.Pos[1]+"] is not a type 'Point on object'.<br> This locus may not work properly. <br><br>";
          }
        
        return output;
    }
        // * * * * * /LOCUS /