
    
  
  var code_to_mem;

  window.onload = function() {

      const index_updated = { 
                          date: "2018/08/24 ",
                          time: "11:42",
                        };
      const convertor_updated = {
                              date : "2018/08/24 ",
                              time : "11:44",
                            };

      document.getElementById('lastupdateindex-date').innerHTML = index_updated.date + index_updated.time;
      document.getElementById('lastupdatecore-date').innerHTML = convertor_updated.date + convertor_updated.time;

    $("#addmathjax").change(function() {
      if ($(this).prop('checked') ==true) {
        $("#mathjax_source").prop('disabled', false);
        $("#mathjax_source_text").css('color','#ddd');
      }
      else {
        $("#mathjax_source").prop('disabled', true);
        $("#mathjax_source_text").css('color','#888');
      }
    });

    //button styling -button
    $("#usebuttonstyle").change(function() {
      if ($(this).prop('checked') ==true) {
        $(".button_options_selection").prop('disabled', false);
              }
      else {
        $(".button_options_selection").prop('disabled', true);
      }
    });

    //document.getElementById('fileinput').addEventListener('change', readSingleFile(), false);
    //document.getElementById('filehtmlinput').addEventListener('change', readFullPageFile(), false);

  }
    

        //copy codearea to err_jspcode for submitting errors
//
//    $('#codearea').bind('input propertychange', function() {
//        document.getElementById('err_jspcode').value = this.value;
//    });

  /* clearAll()
    *Clears all wanted elements in html page  [called by elements id]
  */


  /* copyToClipboard
    *Helpfunction to copy JXGcode to clipboard.
    */
  function copyToClipboard() {
      document.getElementById('jsxcode').select();
      document.execCommand('copy');
      //alert("Copying done!");
  }

  function copyJSPToClipboard() {
    document.getElementById('jspgeneratedcode').select();
    document.execCommand('copy');
  }

  /* openNewWindow
    Is used when link is wanted to open in new window.
  */
  function openNewWindow(link) {  
    window.open(link, link, "toolbar=0,status=0,menubar=0,scrollbars=1");
  }
  function openNewConverterWindow(link) {
    window.open(link, link, "fullscreen=yes, status=0");
  }
  function editJSXcode(link, code, img) {
    if (link == 0) document.getElementById('hidden_jsx_editor_value').innerHTML = "";
    else document.getElementById('hidden_jsx_editor_value').innerHTML = "1";
    window.open('JSXeditor.html','JSXeditor.html', 'fullscreen=yes');
  }


  function inputCodeAndValues(codetxt) {
    var sizew=400, sizeh=400; bname="JSXBoard", ename="id"
    sizew = getWidthHeight(codetxt)[0];
    sizeh = getWidthHeight(codetxt)[1];
    if (codetxt.indexOf("BNAME=")>=0 && codetxt.indexOf("#BNAME")>=0)
      bname = codetxt.slice(codetxt.indexOf("BNAME=")+6, codetxt.indexOf("#"));
    if (codetxt.indexOf("ENAME=")>=0 && codetxt.indexOf("#ENAME")>=0)
      ename = codetxt.slice(codetxt.indexOf("ENAME=")+6, codetxt.indexOf("#", codetxt.indexOf("#")+1));
    if (!checkJSPStyle(codetxt))
      codetxt = codetxt.slice(codetxt.indexOf("$"), codetxt.lastIndexOf(";")+1);
    else codetxt = codetxt.slice(codetxt.indexOf("{"), codetxt.lastIndexOf(";")+1);
    //alert(codetxt);
    //codetxt = codetxt.replace(/&amp;/g, '&');
    //document.getElementById('hiddencode').innerHTML = codetxt;
    //codetxt = document.getElementById('hiddencode').text();
    document.getElementById('codearea').value = codetxt;
    document.getElementById('boardwidthinput').value = sizew;
    document.getElementById('boardheightinput').value = sizeh;
    document.getElementById('jsxgboardname').value = bname;
    document.getElementById('jsxgelementid').value = ename;    
    clearAll(['jsxgimage','jsxgcode','JSketchPadCode','testing','errormessages'], ['err_comms', 'err_info', 'err_submit_btn', 'ERRORS']);  
    document.getElementById('ERRORS').style.display = "inline-block";  
    jspToJsx('codearea');
  }

  function convertPagetoJSX(codetxt) {
    var imglisting=[], sizelisting=[], namelisting=[], convertedlisting=[], tmp="";
    

    while (codetxt.indexOf('<APPLET')>=0) {
      tmp = codetxt.slice(codetxt.indexOf('<APPLET'), codetxt.indexOf('</APPLET>')+9);
      codetxt = codetxt.replace(tmp, "<REPAPPLET>");
      imglisting.push(tmp);
    }
    
    for (var i=0; i<imglisting.length; i++) {
      sizelisting.push(getWidthHeight(imglisting[i]));
    }
    for (var i=0; i<imglisting.length; i++) {
      namelisting.push("img_"+i);
    }

    for (var i=0; i<imglisting.length; i++) {
      imglisting[i] = imglisting[i].slice(imglisting[i].indexOf('{'), imglisting[i].lastIndexOf(';')+1);
    }

    for (var i=0; i<imglisting.length; i++) {     
      convertedlisting.push(jspToJsx(imglisting[i], sizelisting[i], namelisting[i], true));    
    }

    for (var i=0; i<convertedlisting.length; i++) {
      codetxt = codetxt.replace("<REPAPPLET>", convertedlisting[i]);
    }

    document.getElementById("codearea").value = codetxt;

    document.getElementById("loading").style.display = "none";
    
    document.getElementById("jsxgimage").innerHTML = "All "+convertedlisting.length+" images converted ok!<br><br><input onclick='downloadConvPage()' value='Save converted html' type='button' class='browseButton'>";

    clearAll(['jsxgcode','JSketchPadCode','testing'], ['err_comms', 'err_info', 'err_submit_btn']);

    //alert("All "+convertedlisting.length+" images converted ok!");
    
    return null;
  }

  /* source: http://www.htmlgoodies.com/beyond/javascript/read-text-files-using-the-javascript-filereader.html#fbid=40sibQt8vco
    */
  function readSingleFile(evt) {
    //Retrieve the first (and only!) File from the FileList object
    var f = evt.target.files[0]; 

    if (f) {
      var r = new FileReader();
      r.onload = function(e) { 
        var contents = e.target.result;
        inputCodeAndValues(contents);
      }
      r.readAsText(f);
    } 
    else
      alert("Failed to load file");
  }

  function readFullPageFile(evt) {
    //Retrieve the first (and only!) File from the FileList object
    var f = evt.target.files[0]; 
    
    document.getElementById("loading").style.display = "block";
      
    if (f) {
      var r = new FileReader();
      r.onload = function(e) { 
        var contents = e.target.result;

        convertPagetoJSX(contents);
      }
      r.readAsText(f);
    } 
    else
      alert("Failed to load file");
  }

  //function downloadFile(){
  function downloadJSX(){
    var text=document.getElementById('jsxcode').value;
    var filename = document.getElementById('jsxgboardname').value +".html";
    var blob = new Blob([text], {type: "text/plain"});
    var url = window.URL.createObjectURL(blob);
    var a = document.createElement("a");
    a.href = url;
    a.download = filename;
    a.click();
  }

  //function downloadConvPage(){
  function downloadConvPage(){
    var text=document.getElementById('codearea').value;
    var filename = "convertedpage.html";
    var blob = new Blob([text], {type: "text/plain"});
    var url = window.URL.createObjectURL(blob);
    var a = document.createElement("a");
    a.href = url;
    a.download = filename;
    a.click();
  }

  function selectChangeCourse() { 

    var selected_course;
    var mjk2018_codes;
    var test_codes;
    
    try {

      selected_course = document.getElementById('course-selection').value;
      mjk2018_codes = document.getElementById('mjk2018_codes');
      test_codes = document.getElementById('examplecodes');
            
      if (selected_course == 'mjk2018') {
        test_codes.style.display = "none";
        mjk2018_codes.style.display = "inline-block";
      }
      else if (selected_course == 'testing') {
        test_codes.style.display = "inline-block";
        mjk2018_codes.style.display = "none";
      }

    }catch(e) {alert(e.message);}
  }

  function selectChange(s) {
    //var selected = "";
    //alert(s);

    try {
      //selected = document.getElementById('examplecodes').value;
      //var examplecontents = document.getElementById(selected).innerHTML;      
      if (/*selected.indexOf('mjk2018')>=0*/s=='mjk2018_codes') 
        inputCodeAndValues(getSelectedMJK(document.getElementById(s).value));
      else
        inputCodeAndValues(getSelectedExample(document.getElementById(s).value));
      //alert("Loaded code "+selected);
    } catch(e) {alert(e.message);}
  }

  function getWidthHeight(codetxt) {
    var goodChar="0123456789", goodWidth=["WIDTH", "width", "Width"], goodHeight=["HEIGHT", "height", "Height"], indx1=0, indx2=0, w="", h="";

    for (var i=0; i<goodWidth.length; i++) {
      if (codetxt.indexOf(goodWidth[i])>=0) {
        indx1 = codetxt.indexOf(goodWidth[i]);
        while (goodChar.indexOf(codetxt[indx1])==-1)
          indx1++;
        indx2 = indx1;
        while (goodChar.indexOf(codetxt[indx2])>=0)
          indx2++;
        w = codetxt.slice(indx1, indx2);
        indx1=0; indx2=0;

      }
    }
    if (w.lenght<1) alert("Load error. File has no width value.");
    for (var i=0; i<goodHeight.length; i++) {
      if (codetxt.indexOf(goodHeight[i])>=0) {
        indx1 = codetxt.indexOf(goodHeight[i]);
        while (goodChar.indexOf(codetxt[indx1])==-1)
          indx1++;
        indx2 = indx1;
        while (goodChar.indexOf(codetxt[indx2])>=0)
          indx2++;
        h = codetxt.slice(indx1, indx2);
        indx1=0; indx2=0;
      }
    }
    if (h.lenght<1) alert("Load error. File has no height value.");
    return [w,h];  
  }

  /* clearArea
    */
  function clearArea() {
    document.getElementById('codearea').value="";
    document.getElementById('codearea').select();
  }

  function runMathJax() {
    MathJax.Hub.Queue(["Typeset",MathJax.Hub]);
  }

  /*
  * Hide/Open menuarea and enlarge/shrink codearea
  */

  function enlargeCodearea(t) {
    var menus = document.getElementById('menuarea');
    var editor = document.getElementById('left-column-editor-area');
    var codebox = document.getElementById('codearea');
    
    var arrow_down = document.getElementById('menuarea_hiddener');
    var arrow_up = document.getElementById('menuarea_opener');
    
    var exp_height = window.screen.availHeight / 1.3;

    if (t==1) {
      
      menus.style.display = "none";
      editor.style.height = exp_height+"px";
      codebox.rows = "60";
      arrow_down.style.display = "none";
      arrow_up.style.display = "block";
    }

    else {
      
      menus.style.display = "block";
      editor.style.height = "500px";
      codebox.rows = "32";
      arrow_down.style.display = "block";

      arrow_up.style.display = "none";      
    } 
    return true;
  }

  function switchDollarJSPtoJSP(codearea) {
    var code = document.getElementById(codearea).value;
    code_to_mem = code;
    alert(varJSPtoNumJSP(code));
    document.getElementById(codearea).value = varJSPtoNumJSP(code);
  }

  function JspCodeAddRows() {
    var code = document.getElementById('codearea').value;

    code = code.replace(/; /g, ';');
    code = code.replace(/;/g, ';\n');

    document.getElementById('codearea').value = code;
  }
  function JspCodeDeleteRows() {
    var code = document.getElementById('codearea').value;

    code = code.replace(/\n\n/g, '\n');
    //code = code.replace(/;/g, ';\n');
    code = code.replace('{', '\n {');
    code = code.replace('$', '\n $');
    document.getElementById('codearea').value = code;
  }

