function trimJspCode(code_input) {  
  var code = "",
    coderows = [],
    row = [],
    all_refs = [],
    hidden_and_not_ref = [],
    out = '',
    tmp = ''; 

  //read JSP-code
  code= document.getElementById(code_input).value.replace(/(\r\n|\n|\r|" ")/gm,"");
  code = code.replace(/(\t)/gm, " ");
  code = code.trim();

  if (!codeDummyTest(code)) {
    alert('There is some problems in your JSP-code. Check your code!');
    return false;
    //
  }

  coderows = separateCommands(code);

  for (var i=0; i<coderows.length; i++) {
    row[i] = sketchpadrowToJsxgElement(coderows[i]);     
    row[i] = getElemRefs(row[i]);
    //tmp = tmp + "\n" + row[i].Ref + ", is visible: " + row[i].Att.Visible;
  }
  try {
    for (var i=0; i<row.length; i++) {
      all_refs = all_refs.concat(row[i].Ref);
    } //alert(all_refs);
  } catch(e){alert(e.message);}

  all_refs = uniq_fast(all_refs);
  
  try {
    for (var i=0; i<row.length; i++) {
      if (contains(all_refs, row[i].Row)) row[i].isReferred = true;
      else row[i].isReferred = false;
      
      if (!row[i].Att.Visible && !row[i].isReferred && row[i].Type != 'UnitPoint') {
        hidden_and_not_ref.push(row[i].Row);
        tmp = tmp + "\n" + row[i].Orig;
      }
    } 
    if (hidden_and_not_ref.length>0) {
      tmp = 'These '+hidden_and_not_ref.length+' lines can be removed from the JSP-code:\n' +tmp + "\n\nDelete these lines?";
    } else {tmp = "Nothing can be removed."; alert(tmp); return false;}
  } catch(e) {alert(e.message);}

  if (confirm(tmp)) {
    var len = hidden_and_not_ref.length;
    for(var i=len-1; i>-1; i--) 
      row.splice(hidden_and_not_ref[i]-1, 1);
    for (var i=0; i<row.length; i++)
      out = out + row[i].Orig +'\n';
    document.getElementById(code_input).value = out;
    alert('Deleted '+len+ ' lines.');
    return true;
  }
  return false;
}

  function clearAll(clearlist, hidelist, hideclass) {

    var hide_all_class;

    //clear innerHTML
    for (var i=0; i<clearlist.length; i++) document.getElementById(clearlist[i]).innerHTML = "";
    //hide elements
    for (var i=0; i<hidelist.length; i++) document.getElementById(hidelist[i]).style.display = "none";

    if (hideclass) {
      hide_all_class = document.getElementsByClassName(hideclass);
      for (var i=0; i<hide_all_class.length; i++)
        hide_all_class[i].style.display = "none";
    }

  }